Index: ChangeLog
===================================================================
--- ChangeLog	(revision c5f3b461489c70bb84c7575cd4338048a8f9baf1)
+++ ChangeLog	(revision 836ea3a33ae3b7678a5e6a78b57dd7c33e014f8f)
@@ -1,4 +1,8 @@
 $Id$
 
+2.0.9-pre-1
+	Added errqueue.
+	Added command "show errors".
+	
 2.0.8
 	Increased size of screen name field in buddy listing
Index: aim.c
===================================================================
--- aim.c	(revision ec6ff526f80f4544b68f01e84ccd88c783e54326)
+++ aim.c	(revision 836ea3a33ae3b7678a5e6a78b57dd7c33e014f8f)
@@ -225,7 +225,7 @@
 {
   if (message) {
-    owl_function_makemsg(message);
+    owl_function_error(message);
   } else {
-    owl_function_makemsg("Authentication error on login");
+    owl_function_error("Authentication error on login");
   }
   owl_function_beep();
@@ -1596,5 +1596,4 @@
   
   /* printf("snac threw error (reason 0x%04x: %s)\n", reason, (reason<msgerrreasonslen)?msgerrreasons[reason]:"unknown"); */
-  owl_function_makemsg(msgerrreasons[reason]);
   
   return 1;
Index: logging.c
===================================================================
--- logging.c	(revision e6449bc3713fa8e0d1af7b15ef39089c748ae567)
+++ logging.c	(revision 836ea3a33ae3b7678a5e6a78b57dd7c33e014f8f)
@@ -28,5 +28,5 @@
   file=fopen(filename, "a");
   if (!file) {
-    owl_function_makemsg("Unable to open file for outgoing logging");
+    owl_function_error("Unable to open file for outgoing logging");
     owl_free(logpath);
     return;
@@ -42,5 +42,5 @@
   file=fopen(filename, "a");
   if (!file) {
-    owl_function_makemsg("Unable to open file for outgoing logging");
+    owl_function_error("Unable to open file for outgoing logging");
     return;
   }
@@ -68,5 +68,5 @@
   file=fopen(filename, "a");
   if (!file) {
-    owl_function_makemsg("Unable to open file for outgoing logging");
+    owl_function_error("Unable to open file for outgoing logging");
     owl_free(logpath);
     return;
@@ -82,5 +82,5 @@
   file=fopen(filename, "a");
   if (!file) {
-    owl_function_makemsg("Unable to open file for outgoing logging");
+    owl_function_error("Unable to open file for outgoing logging");
     return;
   }
@@ -179,5 +179,5 @@
   file=fopen(filename, "a");
   if (!file) {
-    owl_function_makemsg("Unable to open file for incoming logging");
+    owl_function_error("Unable to open file for incoming logging");
     return;
   }
@@ -187,5 +187,5 @@
     allfile=fopen(allfilename, "a");
     if (!allfile) {
-      owl_function_makemsg("Unable to open file for incoming logging");
+      owl_function_error("Unable to open file for incoming logging");
       fclose(file);
       return;
Index: util.c
===================================================================
--- util.c	(revision f1e629de3f6889c21f5f9dd7225e11c4fe9408b4)
+++ util.c	(revision 836ea3a33ae3b7678a5e6a78b57dd7c33e014f8f)
@@ -726,5 +726,5 @@
   file=fopen(filename, "r");
   if (!file) {
-    owl_function_makemsg("Error opening file %s", filename);
+    owl_function_error("Error opening file %s", filename);
     return;
   }
@@ -735,5 +735,5 @@
     backupfile=fopen(backupfilename, "w");
     if (!backupfile) {
-      owl_function_makemsg("Error opening file %s for writing", backupfilename);
+      owl_function_error("Error opening file %s for writing", backupfilename);
       owl_free(backupfilename);
       return;
@@ -773,5 +773,5 @@
   file=fopen(filename, "w");
   if (!file) {
-    owl_function_makemsg("WARNING: Error opening %s for writing.  Use %s to restore.", filename, backupfilename);
+    owl_function_error("WARNING: Error opening %s for writing.  Use %s to restore.", filename, backupfilename);
     owl_function_beep();
     owl_free(line);
Index: variable.c
===================================================================
--- variable.c	(revision f1e629de3f6889c21f5f9dd7225e11c4fe9408b4)
+++ variable.c	(revision 836ea3a33ae3b7678a5e6a78b57dd7c33e014f8f)
@@ -477,17 +477,17 @@
   v = owl_dict_find_element(d, name);
   if (v == NULL) {
-    if (msg) owl_function_makemsg("Unknown variable %s", name);
+    if (msg) owl_function_error("Unknown variable %s", name);
     return -1;
   }
   if (!v->set_fromstring_fn) {
-    if (msg) owl_function_makemsg("Variable %s is read-only", name);
+    if (msg) owl_function_error("Variable %s is read-only", name);
     return -1;   
   }
   if (requirebool && v->type!=OWL_VARIABLE_BOOL) {
-    if (msg) owl_function_makemsg("Variable %s is not a boolean", name);
+    if (msg) owl_function_error("Variable %s is not a boolean", name);
     return -1;   
   }
   if (0 != v->set_fromstring_fn(v, value)) {
-    if (msg) owl_function_makemsg("Unable to set %s (must be %s)", name, 
+    if (msg) owl_function_error("Unable to set %s (must be %s)", name, 
 				  owl_variable_get_validsettings(v));
     return -1;
Index: zwrite.c
===================================================================
--- zwrite.c	(revision 9ceee9d93177e80e7794f45d5ba9e611169e4d55)
+++ zwrite.c	(revision 836ea3a33ae3b7678a5e6a78b57dd7c33e014f8f)
@@ -30,5 +30,5 @@
   argv=myargv=owl_parseline(line, &argc);
   if (argc<0) {
-    owl_function_makemsg("Unbalanced quotes");
+    owl_function_error("Unbalanced quotes in zwrite");
     return(-1);
   }
@@ -135,5 +135,5 @@
       !strcasecmp(z->inst, "personal") &&
       owl_list_get_size(&(z->recips))==0) {
-    owl_function_makemsg("You must specify a recipient");
+    owl_function_error("You must specify a recipient for zwrite");
     return(-1);
   }